<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003 Gary (gniemcew@yahoo.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Page HTTPS (SSL) Enforcer' for the 'https_enforcer' extension.
 *
 * @author	Gary <gniemcew@yahoo.com>
 *
 * Latest updates and coding guidelines update: Michael Stucki <michael@typo3.org> (thanks!)
 *
 */

require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_httpsenforcer_pi1 extends tslib_pibase	{
	var $prefixId = 'tx_httpsenforcer_pi1';
	var $scriptRelPath = 'pi1/class.tx_httpsenforcer_pi1.php';
	var $extKey = 'https_enforcer';
	var $conf;

	function main($content,$conf)	{
		$this->conf = $conf;

		if ($this->ext_requiresSSL() && !$this->ext_isSSL())	{
			$typo3_root = $this->conf['secure_typo3_root'];
			$url = 'https://' . $typo3_root . '/' . $this->ext_getBaseURI();
			$this->ext_hardRedirect($url);
		} elseif (!$this->ext_requiresSSL() && $this->ext_isSSL())	{
			$typo3_root = $this->conf['unsecure_typo3_root'];
			$url = 'http://' . $typo3_root . '/' . $this->ext_getBaseURI();
			$this->ext_hardRedirect($url);
		}
	}

	function ext_getPageVar($var)	{
		global $TSFE;
		return $TSFE->page[$var];
	}

	function ext_isSSL($port = 443)	{
		if(@$GLOBALS['HTTP_SERVER_VARS']['SERVER_PORT'] != $port)	{ return false; }
		if(@$GLOBALS['HTTP_SERVER_VARS']['HTTPS'] != 'on')	{ return false; }
		return true;
	}

	function ext_requiresSSL()	{
		if($this->ext_getPageVar('tx_httpsenforcer_force_secure') || $this->conf['require_ssl'])	{
			return true;
		}
	}

	function ext_hardRedirect($url)	{
		// header("HTTP 302 Redirect");
		header('Location: '.$url);
		exit;
	}

	function ext_getBaseURI()	{
		return basename(t3lib_div::getIndpEnv('TYPO3_REQUEST_URL'));
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/https_enforcer/pi1/class.tx_httpsenforcer_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/https_enforcer/pi1/class.tx_httpsenforcer_pi1.php']);
}

?>
